import numpy as np

# Declada função para criar listas entre dois numeros, incluindo ambos.
def faixa(a,b):
    if b>a:
        return range(a,b+1,1)
    else:
        return range(a,b-1,-1)

# Declara mesma rotina, mas automaticamente subtraindo 1 de ambos os argumentos
def faixa0(a,b):
    return faixa(a-1,b-1)


# Rotina para resolução de sistema Triangular Superior.
def ts(a1,b1):
    # Copia os argumentos para poder manipula-los
    a=a1.copy()
    b=b1.copy()

    n=np.size(b)
    x=np.zeros(n);

    x[n-1]=b[n-1]/a[n-1,n-1];
    for k in faixa(n-1,1):
        soma=b[k-1]
        for j in faixa(k+1,n):
            soma=soma-a[k-1,j-1]*x[j-1]
        x[k-1]=soma/a[k-1,k-1]

    return x



# Eliminação Gaussiana.
def eg(a1,b1):
    a=a1.copy()
    b=b1.copy()
    # Obtem número de equacões a partir do tamanho do vetor b
    n=np.size(b)
   
    # Loop sobre todas as n linhas (0 até n-1)
    for ilin in faixa(1,n-1):
        #######################################
        # Encontra pivot não nulo #############
        # Loop sobre as linhas abaixo de ilin
        ok=False
        for llin in faixa(ilin,n):
            # Se encontrar, sai do loop. Se não continua procurando.
            if a[llin-1,ilin-1]!=0:
                ok=True
                break
        if not ok:
            # Terminou o loop e não encontrou ninguem, 
            # sai da função com valor None. 
            print('Todos os Pivots são nulos! Matriz A não é inversível.')
            return None,None
        # Se a linha encontrada for diferente, troca.
        if ilin!=llin:
            print('Trocando linha %d por %d'&(ilin,llin))
            tmp1 = a[ilin-1]
            tmp2 = a[llin-1]
            a[ilin-1] = tmp2
            a[llin-1] = tmp1

            tmp1 = b[ilin-1]
            tmp2 = b[llin-1]
            b[ilin-1]=tmp2
            b[llin-1]=tmp1
        ####################################
        # Continua com o algorítmo
        # Loop nas linhas abaixo ilin
        for klin in faixa(ilin+1,n):
            m=a[klin-1,ilin-1]/a[ilin-1,ilin-1]
            b[klin-1] = b[klin-1] - m*b[ilin-1]
                
            # coeficiente antes da diagona torna-se explicitamente zero.
            a[klin-1, ilin-1] = 0
            # Loop nos coeficientes jcol da linha klin
            for jcol in faixa(ilin+1,n):
                a[klin-1,jcol-1] = a[klin-1,jcol-1] - m*a[ilin-1,jcol-1]
    return a,b

